require('vcl')


function Form_onMouseMove(Sender, Shift, X, Y)
	-- Form.MainPage.RulesTab.EditRuleButton.Visible=false
end

function cbRules_onMouseMove(Sender, Shift, X, Y)
	-- Form.MainPage.RulesTab.EditRuleButton._ = { Visible=true, Top=Sender.Top, Hint='  "'..Sender.Caption..'"',
		-- Left=Sender.Left-Form.MainPage.RulesTab.EditRuleButton.Width-10, Height=Sender.Height }
end

function StartEditDialog(Sender)
	local fcontent

	local function get_rules_block(name)
		local f, err = io.open(hc.script_name:match('.*\\') .. 'ContentMaster_Default.txt', 'rb')
		if not f then
			hc.put_msg('Content Master:\r\n', err)
			return
		end
		fcontent = f:read('*a')
		local block = re.find(fcontent, [[^\#\#\s*+]] .. name .. [[.*?$\K.*?\r\n(?:\r\n|\z)]])
		f:close()
		local t = {}
		for str in block:gmatch('[^\r\n]+') do
			table.insert(t, {#t+1, re.find(str, [[^\s*+(.*?)\#~\#(.*?)\#\~\#(.*?)$]], 1), re.substr(2), re.substr(3)})
		end
		return t
	end

	local function set_rules_block(name)
		local t = {}
		for i=2,_CM_EditDialog.Grid.RowCount do
			table.insert(t, table.concat(_CM_EditDialog.Grid:GetRow(i), '#~#', 2))
		end
		fcontent = re.replace(fcontent, [[\#\#\s*+]] .. name .. [[.*?^\K.*?(?=\r\n(?:\r\n|\z))]], table.concat(t, '\r\n'))
		local f, err = io.open(hc.script_name:match('.*\\') .. 'ContentMaster_Default.txt', 'wb')
		if not f then
			hc.put_msg('Content Master:\r\n', err)
			return
		end
		f:write(fcontent)
		f:close()
	end

	local t = get_rules_block('REPLACEMENTS')
	_CM_EditDialog = VCL.Form('EditDialog')
	_CM_EditDialog._ = { Caption=Sender.Hint, ClientWidth=900,
		Position='poOwnerFormCenter',	BorderIcons='biSystemMenu', BorderStyle='Fixed3D' }
	_CM_EditDialog.FileSelector = VCL.ComboBox(_CM_EditDialog, 'FileSelector')
	_CM_EditDialog.FileSelector._ = { Left=5, Top=5, Style='csDropDownList' }
	_CM_EditDialog.Grid = VCL.StringGrid(_CM_EditDialog, 'Grid')
	_CM_EditDialog.Grid._ = { DefaultRowHeight=20, FixedColor=15268314, ColCount=4, OnRowMoved='onRowMoved', Left=5, Top=30,
		Options=_CM_EditDialog.Grid.Options .. ',goEditing,goColSizing,goRowMoving,goAlwaysShowEditor' }
	_CM_EditDialog.Grid:SetRow(1, {'', 'URL', '', ''})
	for i,v in ipairs(t) do
		_CM_EditDialog.Grid:SetRow(i+1, v)
	end
	local FirstColWidth = 20
	_CM_EditDialog.Grid:SetColWidth(1, FirstColWidth)
	local len = _CM_EditDialog.ClientWidth - FirstColWidth - 25
	_CM_EditDialog.Grid:SetColWidth { FirstColWidth, len*0.2, len*0.6, len*0.2 }
	_CM_EditDialog.Grid.Height = _CM_EditDialog.Grid.DefaultRowHeight * _CM_EditDialog.Grid.RowCount + 27
	_CM_EditDialog.Grid.Width = FirstColWidth + len*0.2 + len*0.6 + len*0.2 + 27
	_CM_EditDialog.ClientHeight = _CM_EditDialog.Grid.DefaultRowHeight * _CM_EditDialog.Grid.RowCount + 150
	_CM_EditDialog.OKButton = VCL.BitButton(_CM_EditDialog, 'OKButton')
	_CM_EditDialog.OKButton._ = { Kind='bkOK', Width=110, Height=27, Left=30 }
	_CM_EditDialog.OKButton._ = { Caption='', Top=_CM_EditDialog.ClientHeight-_CM_EditDialog.OKButton.Height-14 }
	_CM_EditDialog.CancelButton = VCL.BitButton(_CM_EditDialog, 'CancelButton')
	_CM_EditDialog.CancelButton._ = { Kind='bkCancel', Width=110, Height=_CM_EditDialog.OKButton.Height,
		Left=_CM_EditDialog.OKButton.Left+_CM_EditDialog.OKButton.Width+10, Top=_CM_EditDialog.OKButton.Top }
	_CM_EditDialog.CancelButton._ = { Caption='' }
	local FormResult = _CM_EditDialog:ShowModal()
	if FormResult=='mrOk' then
		set_rules_block('REPLACEMENTS')
	end
	_CM_EditDialog:Free()
	_CM_EditDialog = nil
end

function onRowMoved(Sender, FromIndex, ToIndex)
	local min = FromIndex<ToIndex and FromIndex or ToIndex
	local max = FromIndex>ToIndex and FromIndex or ToIndex
	for i=min,max do
		local t = Sender:GetRow(i)
		t[1] = i-1
		Sender:SetRow(i, t)
	end
end

function onViewLogButtonClick(Sender)
	hc.shell_execute('notepad.exe', hc.script_name:match('.*%.') .. 'log', nil, 'SW_SHOW')
end

function onClearLogButtonClick(Sender)
	os.remove(hc.script_name:match('.*%.') .. 'log')
	Sender.Enabled = false
	Form.ToolBarPanel.ToolBar.ViewLogButton.Enabled = false
end

function cbRuleGroupOnClick(Sender)
	local i = tonumber(re.find(Sender.Name, [[\d+]]))
	if edFiles[i] then
		edFiles[i].Enabled = Sender.Checked
	end
	for j,v in ipairs(cbRules[i]) do
		v.Enabled = Sender.Checked
		if lblHits[i][j] then
			lblHits[i][j].Enabled = Sender.Checked
		end
	end
end



if not _CM_ then
	_CM_ = hc.get_global('CM_DATA')
end
if Form then
	Form:Free()
	Form=nil
end
local hei = 120
for i,v in ipairs(_CM_.Data) do
	hei = hei + 20 + 20*#v.Rules + 10
end

Form = VCL.Form('Form')
Form.OKButton = VCL.BitButton(Form, 'OKButton')
Form._ = { Caption=' Content Master', Width=600, ClientHeight=hei+Form.OKButton.Height+20,
	Position='poOwnerFormCenter',	BorderIcons='biSystemMenu', BorderStyle='Fixed3D', OnMouseMove='Form_onMouseMove' }

Form.OKButton._ = { Kind='bkOK', Width=110, Height=27, Left=30, Top=Form.ClientHeight-Form.OKButton.Height-14 }
Form.OKButton._ = { Caption='' }
Form.CancelButton = VCL.BitButton(Form, 'CancelButton')
Form.CancelButton._ = { Kind='bkCancel', Width=110, Height=Form.OKButton.Height, Left=Form.OKButton.Left+Form.OKButton.Width+10, Top=Form.OKButton.Top }
Form.CancelButton._ = { Caption='' }
Form.UpdateButton = VCL.BitButton(Form, 'UpdateButton')
Form.UpdateButton._ = { Kind='bkRetry', Width=110, Height=Form.OKButton.Height, Top=Form.OKButton.Top }
Form.UpdateButton._ = { Caption=' ', Left=Form.ClientWidth-Form.OKButton.Left-Form.UpdateButton.Width }

Form.MainPage = VCL.PageControl(Form, 'MainPage')
Form.MainPage._= { Width=Form.ClientWidth, Height=Form.ClientHeight-Form.OKButton.Height-20, Left=1 }
Form.MainPage.RulesTab = VCL.TabSheet(Form.MainPage, 'RulesTab')	--  
Form.MainPage.RulesTab._= { Caption='' }

tabGlobalExceptions = VCL.TabSheet(Form.MainPage, 'tabGlobalExceptions')	--  
tabGlobalExceptions._= { Caption='' }
memoGlobalExceptionList = VCL.Memo(tabGlobalExceptions,"memoGlobalExceptionList")
lblHotKey = VCL.Label(tabGlobalExceptions, 'lblHotKey')
lblHotKey._ = { Caption='   :', Top=10, Left=10, ShowHint=true,
	Hint="     'VK_'\r\n" ..
	"     http://api.farmanager.com/ru/winapi/virtualkeycodes.html" }
edHotKey = VCL.Edit(tabGlobalExceptions, 'HotKey')
edHotKey._ = { Text=_CM_.CM_Off_Hotkey:gsub('VK_', ''), ShowHint=lblHotKey.ShowHint, Hint=lblHotKey.Hint,
	Top=lblHotKey.Top-4, Left=lblHotKey.Left+lblHotKey.Width+10 }
lblGlobalExceptionList = VCL.Label(tabGlobalExceptions, "lblGlobalExceptionList")
lblGlobalExceptionList._ = { Caption=' ,   Content Master  ( ):',
	Top=edHotKey.Top+edHotKey.Height+8, Left=lblHotKey.Left }
memoGlobalExceptionList._ = { Top=lblGlobalExceptionList.Top+lblGlobalExceptionList.Height+5, Left=lblGlobalExceptionList.Left,
	Width=tabGlobalExceptions.Width-2*lblGlobalExceptionList.Left }
memoGlobalExceptionList._ = { Scrollbars='ssVertical', WordWrap=false, Height=Form.MainPage.Height-memoGlobalExceptionList.Top-5-35 }
memoGlobalExceptionList:SetText(_CM_.User_Exceptions_List[1] and _CM_.User_Exceptions_List or '')

cbRuleGroup = {}
cbRules = {}
edFiles = {}
local top_pos = 35
local H = hc.get_global('CM_Hits')
lblHits = {}
for i,v in ipairs(_CM_.Data) do
	cbRuleGroup[i] = VCL.CheckBox(Form.MainPage.RulesTab, 'cbRuleGroup'..i)
	cbRuleGroup[i]._= { Caption=v.Name, Top=top_pos, Left=25, Width=180, Checked=v.On, OnClick='cbRuleGroupOnClick' }
	if v.File then
		edFiles[i] = VCL.Edit(Form.MainPage.RulesTab, 'edFiles'..i)
		edFiles[i]._ = { Text=v.File, ShowHint=true, Hint=' - ' .. re.find(v.Name, [[\s\K\w.*]]) .. '  ', Left=cbRuleGroup[i].Left+cbRuleGroup[i].Width+20 }
		edFiles[i]._ = { Top=top_pos+20-edFiles[i].Height, Width=Form.MainPage.RulesTab.Width-edFiles[i].Left-cbRuleGroup[i].Left-50, Enabled=cbRuleGroup[i].Checked }
	end
	top_pos = top_pos + cbRuleGroup[i].Height*1.25
	cbRules[i] = {}
	lblHits[i] = {}
	for j,rule in ipairs(v.Rules) do
		cbRules[i][j] = VCL.CheckBox(Form.MainPage.RulesTab, 'cbRules'..i.. '_' ..j)
		cbRules[i][j]._= { Caption=rule.Name, Top=top_pos, Left=cbRuleGroup[i].Left+35,
			Checked=rule.On, Enabled=cbRuleGroup[i].Checked, OnMouseMove='cbRules_onMouseMove' }
		cbRules[i][j]._= { Width=Form.MainPage.RulesTab.Width-cbRuleGroup[i].Left-cbRules[i][j].Left-30 }
		if rule.Counted then
			lblHits[i][j] = VCL.Label(Form.MainPage.RulesTab, 'HitLabel'..i..'_'..j)
			lblHits[i][j]._ = { Caption=tostring(H[i][j] or 0), Top=top_pos, Left=Form.MainPage.RulesTab.Width-cbRuleGroup[i].Left-30, Enabled=cbRuleGroup[i].Checked }
		end
		top_pos = top_pos + cbRuleGroup[i].Height*1.25
	end
	top_pos = top_pos + cbRuleGroup[i].Height*0.6
end
lblHitCounts = VCL.Label(Form.MainPage.RulesTab, 'lblHitCounts')
lblHitCounts._ = { Caption='\r\n', Top=4, AutoSize=true, Alignment='taCenter' }
lblHitCounts._ = { Left=Form.MainPage.RulesTab.Width-lblHitCounts.Width-10 }
-- Form.MainPage.RulesTab.EditRuleButton = VCL.Button(Form.MainPage.RulesTab, 'EditRuleButton')
-- Form.MainPage.RulesTab.EditRuleButton._ = { Caption='...', Visible=false, Width=20,	OnClick='StartEditDialog',
	-- ShowHint=true }

Form.Width = Form.Width + 28
Form.ToolBarPanel = VCL.Panel(Form, 'ToolBarPanel')
Form.ToolBarPanel._ = { Caption='', Left=Form.ClientWidth-27, Top=Form.MainPage.Top+20,
	Height=Form.MainPage.Height, Width=27, BevelWidth=0 }
Form.ToolBarPanel.ToolBar = VCL.ToolBar(Form.ToolBarPanel, 'ToolBar')
Form.ToolBarPanel.ToolBar._ = { AutoSize=true, Align='alLeft', ButtonWidth=26, ButtonHeight=26,
	Height=Form.ToolBarPanel.Height,	Width=Form.ToolBarPanel.Width }
imgList = VCL.ImageList(Form, 'imgList')
imgList:Load((hc.script_name:gsub('(.*\\).*', '%1write_to_log.png')))
imgList:Load((hc.script_name:gsub('(.*\\).*', '%1clear_log.png')))
imgList:Load((hc.script_name:gsub('(.*\\).*', '%1view_log.png')))
Form.ToolBarPanel.ToolBar:Images(imgList)
local f = io.open(hc.script_name:match('.*%.') .. 'log', 'rb')
Form.ToolBarPanel.ToolBar.ClearLogButton = VCL.ToolButton(Form.ToolBarPanel.ToolBar, 'ClearLogButton')
Form.ToolBarPanel.ToolBar.ClearLogButton._ = { ImageIndex=1, Hint=' ', ShowHint=true,
	OnClick='onClearLogButtonClick', Enabled=f~=nil }
Form.ToolBarPanel.ToolBar.ViewLogButton = VCL.ToolButton(Form.ToolBarPanel.ToolBar, 'ViewtLogButton')
Form.ToolBarPanel.ToolBar.ViewLogButton._ = { ImageIndex=2, Hint=' ', ShowHint=true,
	OnClick='onViewLogButtonClick', Enabled=f~=nil }
if f then f:close() end
Form.ToolBarPanel.ToolBar.WriteToLogButton = VCL.ToolButton(Form.ToolBarPanel.ToolBar, 'WriteToLogButton')
Form.ToolBarPanel.ToolBar.WriteToLogButton._ = { Style='tbsCheck', ImageIndex=0, Down=_CM_.LogOn,
	Hint=' ', ShowHint=true }

local FormResult = Form:ShowModal()
if FormResult=='mrOk' then
	for i,v in ipairs(_CM_.Data) do
		v.On = cbRuleGroup[i].Checked
		if edFiles[i] then
			v.File = edFiles[i].Text
		end
		for j,rule in ipairs(v.Rules) do
			rule.On = cbRules[i][j].Checked
		end
	end
	_CM_.LogOn = Form.ToolBarPanel.ToolBar.WriteToLogButton.Down
	_CM_.User_Exceptions_List = memoGlobalExceptionList:GetText()
	local t = _CM_.NoAction_List
	for _,tt in ipairs(_CM_.User_Exceptions_List) do
		if re.find(tt, [[\S]]) then
			local tmp = re.find(nil, [[^\+\K.*]])
			table.insert(t, tmp and toregexp(tmp) or tt)
		end
	end
	_CM_.URL_Exception = t[1] and regexp_from_list(t) or ''
	_CM_.CM_Off_Hotkey = re.replace(edHotKey.Text, [[(?<=^|\s)(?=\S)]], 'VK_', true)

	hc.set_global('CM_DATA', _CM_)
	SaveParams()
	init()
elseif FormResult=='mrRetry' then
	hc.execute_cmd('LoadURL ' .. CM_UpdateCfgURL .. CM_UpdatePostfix)
end
Form:Free()
Form = nil

