
_CM_ = {}
_CM_.Data = {}
_CM_.Lists = {}
_CM_.NoAction_List = {}		--  ,     
local Global_Request_Black_List = {}
local HC_Global_Request_Black_List = {}
local Global_Request_White_List = {}
local HC_Global_Request_White_List = {}

--    r    ,    
local function brackets_if_toplevel_alts(r)
	return re.find(r, [=[\A(?(DEFINE)(?<qe>\\Q.*?\\E)(?<square_brackets>\[(?>\\.|[^\]])*+\])]=] ..
		[=[(?<round_brackets>\((?>(?&qe)|(?&square_brackets)|(?&round_brackets)|\\.|[^)])*+\)))]=] ..
		[=[(?>(?&qe)|(?&round_brackets)|(?&square_brackets)|\\.|[^|])*+\z]=]) and r or ('(?:' .. r .. ')')
end

--  html-  PCRE (     )
_CM_.Lists.html_element = [[<(?!/)(?(DEFINE)(?<attrs>(?>(?(?<![\'"])\s)\s*+[^\s>/=]++(?:\s*+=\s*+(?>'.*?'|".*?"|[^\s>]*+))?)*+\s*+/?)(?<SpecOrScop>a(?:ddress|r(?:ea|ticle)|side)|b(?:ase(?:font)?|gsound|lockquote|ody|r)|c(?:enter|o(?:l(?:group)?|mmand))|d(?:atagrid|[dlt]|etails|i[rv])|embed|f(?:i(?:eldset|gure)|o(?:oter|rm)|rame(?:set)?)|h(?:[1-6r]|ead(?:er)?|group)|i(?:frame|mg|nput|sindex)|li(?:nk|sting)?|me(?:nu|ta)|n(?:av|o(?:embed|frames|script))|ol|p(?:aram|laintext|re)?|s(?:cript|e(?:ction|lect)|tyle)|t(?:body|extarea|foot|head|itle|r)|ul|wbr|xmp|applet|button|caption|html|marquee|object|t(?:able|[dh])))(?>]] ..
	[[form(?&attrs)>(*PRUNE)(?>[^<]++|<form(?&attrs)>|(?&html_element))*?</form\s*+>
	table(?&attrs)>(*PRUNE)(?>[^<]++|(?&html_element))*?(?></table\s*+>|(?<=</tr>)(?=[^<]*+<table[\s>]))
	tr(?&attrs)>(*PRUNE)(?>[^<]++|(?&html_element)|</td\s*+>)*?(?></tr\s*+>|(?=<(?>/(?!td[\s>])|tr[\s>])))
	(?>(t[dh])(?&attrs))>(*PRUNE)(?>[^<]++|(?&html_element)|</(?:body|c(?:aption|ol(?:group)?)|div)\s*+>)*?(?></\g-1\s*+>|(?=<(?>/t(?:able|body|foot|head|r)|t[dhr][\s>])))
	!--.*?-->
	(s(?:cript|tyle)|t(?:extarea|itle))(?&attrs)>(*PRUNE).*?</\g-1\s*+>
	(?>area|b(?:ase|r)|co(?:l|mmand)|embed|frame|hr|i(?:mg|nput)|keygen|link|meta|param|source)(?&attrs)>
	p(?&attrs)>(*PRUNE)(?>[^<]++|(?&html_element))*?(?=<)(?></p\s*+>|(?=<(?>/|(?>a(?>ddress|rticle|side)|blockquote|center|d(?>[dtl]|etails|i[rv])|f(?>i(?>eldset|gure)|o(?>oter|rm))|h(?>[1-6r]|eader|group)|li(?:sting)?+|menu|nav|ol|p(?:laintext|re)?+|section|table|ul|xmp)[\s>])))
	(?>(li|option))(?&attrs)>(*PRUNE)(?>[^<]++|(?&html_element))*?(?></\g-1\s*+>|(?=<(?>/|\g-1[\s>])))
	head(?&attrs)>(*PRUNE)(?>[^<]++|(?&html_element)|</[^\s>]++\s*+>)*?(?:</head\s*+>|(?=</(?:b(?:ody|r)|html)[\s>]))
	([^\s>]++)(?&attrs)>(?>[^<]++|(?&html_element)|</(?&SpecOrScop)\s*+>)*?</\g-1\s*+>)
]]

-- -------------------------     Content Master.ini --------------------------------
local f = io.open(re.replace(hc.script_name, [[(.*\.).*]], [[\1ini]]), 'rb')
local s, sfile
if f then
	sfile = f:read("*a")
	f:close()
end
sfile = sfile or ''

table.insert(_CM_.Data, {
	Name = ' ContentMaster',
	Type = 'ContentMaster',
	File = 'ContentMaster_Default.txt',
	On = true,
})
table.insert(_CM_.Data, {
	Name = ' AdMuncher',
	Type = 'AdMuncher',
	File = 'AdMuncher_Default.txt',
	On = false,
})
table.insert(_CM_.Data, {
	Name = ' AdBlockPlus',
	Type = 'AdBlockPlus',
	On = false,
})
table.insert(_CM_.Data, {
	Name = ' HandyCache',
	Type = 'HandyCache',
	On = true,
})

local Find_Element_By_URL_In_Tag = '(?=<)(?|' .. table.concat({
	[[(?=<(a(?:rea)?+(?=\s)[^>]*?\sping=[^>]++)>)[^>]*?\s\Kping=[\'"]?+(?:[^\s'">]*+\s++)*?([^\s'">]++)[^'"]*+[\'"]?+(?C254)]],
	[[(?=<!--)(?&html_element)(*SKIP)(*F)]],
	[[<(style(?=[\s>])[^>]*+)>(?:(?!</style>).)*?\K(?|@import\s*+(?:\burl\(\"?|\")?+([^"\s)]++)[^;]*+;|]] ..
		[[[^@;{}]++{[^}]*?[\s:]url\(([^\s)]++)[^}]*+\})(?C254)]],
	[[(?=<style[\s>])(?&html_element)(*SKIP)(*F)]],
	[[(?=<(script(?=[\s>])[^>]*+)(?:(?!</script>).)*?(?=(?>https?://|(?<=[\'"=])[\w.-]*+/))([^'"\s]*+)(?C254))]] ..
		[[(?&html_element)(?:\s*+(?=<noscript[\s>])(?&html_element))?]],
	[[(?=<(script(?=[\s>])[^>]*+))(?&html_element)\s*+(?=<noscript[\s>](?:(?!</noscript>).)*?(?=https?://)([^'"\s]*+)]] ..
		[[(?C254))(?&html_element)]],
	[[(?=<([^>]++)>)(?=<[^>]*?\s(?:(?:(?>href|src|background)=[\'"]?+|style=\"[^">]*?\burl\(\'?+)(?=https?:|]] ..
		[[(?!\w++:|\#))|(?>data|value)=[\'"]?+(?=https?:|.{0,2}/))([^'">\s)]*+)[^>]*+(?C254))(?&html_element)]] ..
		[[(?:(?<=</script>)\s*+(?=<noscript[\s>])(?&html_element))?]],
	[[(?=<script[\s>])(?&html_element)(*SKIP)(*F)]],
}, '|') .. ')'
local JS_insert = [[<(?:!DOCTYPE\s*+)?html[\s>].*?\K(?=(?><!--.*?-->\s*+)?<(?:script|style|table|div)[\s>]|</head\s*+>)]]
local CSS_insert = [[<(?:!DOCTYPE\s*+)?html[\s>].*?\K(?:<head[\s>].*?\K(?=</head\s*+>)|(?=(?><!--.*?-->\s*+)?<(?:script|style|table|div)[\s>]))]]

local BreakedBlocks = {}

for i,v in ipairs(_CM_.Data) do
	s= re.find(sfile, toregexp(v.Name) .. '=(true|false)', 1)
	v.On = tostring(s or v.On)=='true'
	BreakedBlocks[i] = true
-- ---------------------------   AdMuncher -----------------------
	if v.Type=='ContentMaster' then
		v.File = re.find(sfile, [[ContentMaster files=\K.+?$]]) or 'ContentMaster_Default.txt'
		local ContentMaster_COMMENT_List = {}
		local ContentMaster_CLASS_ID_List = ContentMaster_COMMENT_List
		local ContentMaster_SCRIPT_List = {}
		local ContentMaster_SIZE_List = {}
		local ContentMaster_REPLACEMENT_List = {}
		for file in v.File:gmatch('[^, ]+') do	--     
			local f, err = io.open(hc.script_name:gsub('(.*\\).*', '%1' .. file), 'rb')
			if f then
				local fil = f:read('*a')
				f:close()
				v.Rules = v.Rules or {}
				if v.On then
					local function Process_CM_Rules_Block(BlockName, List)
						local block = re.find(fil, [[^\#\#\s*+]] .. BlockName .. [[(?=\s).*?$\K.*?(?:\r\n|\z)(?=\s*$)]])
						if block then
							for str in block:gmatch('%S[^\r]+') do
								table.insert(List, str)
							end
						end
					end
					Process_CM_Rules_Block('COMMENTS', ContentMaster_COMMENT_List)
					Process_CM_Rules_Block('CLASS/ID', ContentMaster_CLASS_ID_List)
					Process_CM_Rules_Block('SCRIPT', ContentMaster_SCRIPT_List)
					Process_CM_Rules_Block('SIZE', ContentMaster_SIZE_List)
					Process_CM_Rules_Block('REPLACEMENTS', ContentMaster_REPLACEMENT_List)
				end
				BreakedBlocks[i] = false
			else
				hc.put_msg('Content Master:\r\nFile error:\r\n', err)
			end
		end
		table.insert(v.Rules, {
			Name = '   ()',
			Find = [[(?><!--[\s-]*+(?!>)(?&begin)?\s*+(?&prefix)?\s*+(((?:(?!-->).)*?)\s*+]] ..
				[[(banner|counters?|top100|[]?||?)|(?:]] ..
				regexp_from_list(ContentMaster_COMMENT_List) ..
				[[))\s*+((?&prefix))?(?&begin)?.*?-->)(?:\s*+(?&html_element))*?\s*+]] ..
				[[<!--[\s-]*+(?:(?&end)?\s*+(?&prefix)?\s*+(?:\1|\2)|(?&end)\s*+(?&prefix)?\s*+\3|\s*+\3\s*+]] ..
				[[(?&prefix)?(?&end)|(?&end)\s*+\4|\4(?&end)).*?-->]] ..
				[[(?(DEFINE)(?<begin>\s*+(?>b(?:egin(?:ning)?|of)|start)(?:\s*(?::|of))?)]] ..
				[[(?<end>\s*+(?:end|finish|//?|eof|)(?:\s*+(?::|of))?)(?<prefix>(?:|code|logo|tag)))]],
			Replace = [[<!-- ********** CONTENT MASTER: Fragment deleted by comment: \1 ********* -->]],
		})
		local tmp = regexp_from_list(ContentMaster_CLASS_ID_List)
		table.insert(v.Rules, {
			Name = '  class/id ()',
			Find = [[<!--.*?-->(*SKIP)(*F)|(?=<[^>]+?\s(?:class|id)=[^\s>]*?(]] .. tmp ..
				[[))(?&html_element)|(?=<script[\s>])(?&html_element)(*SKIP)(*F)]],
			Replace = [[<!-- ********** CONTENT MASTER: Tag deleted by class/id: \1 ********* -->]],
			-- Find = [[<!--.*?-->(*SKIP)(*F)|(?|(?=(<td)(?=\s)[^>]*?\s(?:class|id)=[^\s>]*?(]] ..	tmp ..
				-- [[).*?(>))(?&html_element)(?|(?<=(</td>))|())|(?=<[^>]+?\s(?:class|id)=()[^\s>]*?(]] .. tmp ..
				-- [[))()()(?&html_element))|(?=<script[\s>])(?&html_element)(*SKIP)(*F)]],
			-- Replace = [[<!-- ********** CONTENT MASTER: Tag deleted by class/id: \2 ********* -->\1\3\4]],
		})
		table.insert(v.Rules, {
			Name = '      ()',
			Find = [[<!--.*?-->(*SKIP)(*F)|(?=<script[\s>])((?&html_element))(?C254)]] ..
				[[(?:\s*+(?=<noscript[\s>])(?&html_element))?]],
			SubFind = regexp_from_list(ContentMaster_SCRIPT_List),
			Replace = '<!-- ********** CONTENT MASTER: Script deleted by keyword ********* -->',
		})
		table.insert(v.Rules, {
			Name = '   ()',
			Find = [[(?:<!--.*?-->|(?=<script[\s>])(?&html_element))(*SKIP)(*F)|(?=<(?!td[\s>])\w++\s(?:]] ..
				regexp_from_list(ContentMaster_SIZE_List) .. [[))(?&html_element)]],
			Replace = [[<!-- ********** CONTENT MASTER: Element deleted by size ********* -->]],
		})
		for ii,vv in ipairs(ContentMaster_REPLACEMENT_List) do
			local tmp = re.replace(vv, [[\#~\#.*?\K\#~\#(.*)]], [[(?C251)(?#\1)]])
			ContentMaster_REPLACEMENT_List[ii] =
				re.replace(tmp, [[.*?\(\?\#.*?\K\)(*SKIP)(?!$)|\G[^)]*+\K\)(?!$)]], '####', true)
		end
		table.insert(v.Rules, {
			Name = '  ()',
			__CMReplacement = table.concat(ContentMaster_REPLACEMENT_List, '\r\n'),
			Editable = true,
			On = false,
		})
	elseif v.Type=='AdMuncher' then
		v.File = re.find(sfile, [[AdMuncher files=\K.+?$]]) or 'AdMuncher_Default.txt'
		local AdMuncher_Black_List = {}
		local AdMuncher_White_List = {}
		local AdMuncher_IMAGE_List = {}
		local AdMuncher_SCRIPT_List = {}
		local AdMuncher_TABLE_List = {}
		local AdMuncher_DIV_List = {}
		local AdMuncher_ALT_List = {}
		local AdMuncher_FORM_List = {}
		local AdMuncher_POPUP_List = {}
		local AdMuncher_JS_List = {}
		local AdMuncher_CSS_List = {}
		local AdMuncher_REPLACE_List = {}
		local AdMuncher_Request_Black_List = Global_Request_Black_List
		local AdMuncher_Request_White_List = Global_Request_White_List
		for file in string.gmatch(v.File, '[^, ]+') do	--     
			local f, err = io.open(hc.script_name:gsub('(.*\\).*', '%1' .. file), 'rb')
			if f then
				f:close()
				v.Rules = v.Rules or {}
				if v.On then
					for line in io.lines(hc.script_name:gsub('(.*\\).*', '%1' .. file)) do
						local argument = re.find(line, [[(.+?):\s*+\K.+]])
						if argument then
							local action = re.substr(1)
							if action=='No filtering on URL' then
								table.insert(_CM_.NoAction_List, toregexp(argument))
							elseif action=='Remove links to URL' then		--     URL
								table.insert(AdMuncher_Black_List, toregexp(argument))
							elseif action=='Don\'t match against keyword' then
								table.insert(AdMuncher_White_List, toregexp(argument))
								-- table.insert(AdMuncher_Request_White_List, toregexp(argument))
							elseif action=='Remove images/etc with URL' then
								table.insert(AdMuncher_IMAGE_List, toregexp(argument))
							elseif action=='Remove scripts with text' then
								local tmp = re.replace(toregexp(argument), '"', [=[['"]]=], true)
								table.insert(AdMuncher_SCRIPT_List, tmp)
							elseif action=='Remove tables with text' then
								table.insert(AdMuncher_TABLE_List, toregexp(argument))
							elseif action=='Remove divs/spans with text' then
								local tmp = re.replace(toregexp(argument), '"', [=[['"]]=], true)
								table.insert(AdMuncher_DIV_List, tmp)
							elseif action=='Remove images with "alt" text' then
								table.insert(AdMuncher_ALT_List, toregexp(argument))
							elseif action=='Remove forms with text' then
								table.insert(AdMuncher_FORM_List, toregexp(argument))
							elseif action=='Remove all popups from URL' then
								table.insert(AdMuncher_POPUP_List, toregexp(argument))
							elseif action=='Add javascript to all pages' then
								table.insert(AdMuncher_JS_List, argument)
							elseif action=='Add CSS to all pages' then
								table.insert(AdMuncher_CSS_List, argument)
							elseif action=='Block retrieval of URL' then
								table.insert(AdMuncher_Request_Black_List, toregexp(argument))
							elseif action=='Replace text' then
								local tmp = re.find(argument, [[^\|(.*?)\|(.*)]], 1)
								if tmp then
									tmp = string.gsub(toregexp(tmp), '%.%*%?%.%*%?', '(.*?)')
									local tmp2 = toregexp(re.substr(2))
									tmp2 = string.gsub(tmp2:gsub('%.%*%?', '\\1'), '%)', '####')
									table.insert(AdMuncher_REPLACE_List, tmp .. '(?C253)(?#' .. tmp2 .. ')')
								end
							end
						end
					end -- for line
				end
				BreakedBlocks[i] = false
			else
				hc.put_msg('Content Master:\r\nFile error:\r\n', err)
			end	-- if file
		end	-- for file
		if not BreakedBlocks[i] then
			local AM_WL = '(?!.*?(?:' .. regexp_from_list(AdMuncher_White_List) .. '))'
			table.insert(v.Rules, {
				Name = '   URL (AdMuncher)',
				Find = [[(?=<)(?|(?=<(?>!--|s(?>cript|tyle)[\s>]))(?&html_element)(*SKIP)(*F)|]] ..
					[[(?=<(a(?:rea)?+)(?=\s)[^>]*?\shref\s*+=\s*+(?>(?|'(.*?)\'|"(.*?)\"|([^\s>]++)))(?C254))(?&html_element)|]] ..
					[[(?(DEFINE)(?<rels>a(?:lternate|rchives|uthor)|first|help|index|l(?:ast|icense)|next|prev|s(?:earch|idebar)|tag|up))]] ..
					[[(?=<(link)(?=\s)(?=[^>]*?\srel\s*+=\s*+(?>'(?&rels)\'|"(?&rels)\"|(?&rels)[\s>]))]] ..
						[[[^>]*?\shref\s*+=\s*+(?>(?|'(.*?)\'|"(.*?)\"|([^\s>]++)))]] ..
					[[(?C254))(?&html_element))]],
				Replace = '<!-- ********** CONTENT MASTER: Element deleted by AdMuncher. Remove links to URL: \\2 -->',
				SubFind = '\\A(?=.*?(?:' .. regexp_from_list(AdMuncher_Black_List) .. '))' .. AM_WL,
				On = true,
				Type = 'URL',
			})
			table.insert(v.Rules, {
				Name = '   URL (AdMuncher)',
				Method = 'block',
				SubFind = '\\A(?=.*?(?:' .. regexp_from_list(AdMuncher_Request_Black_List) .. '))' .. AM_WL,
				On = true,
				Type = 'URL',
			})
			table.insert(v.Rules, {
				Name = ' -  URL (AdMuncher)',
				Find = re.replace(Find_Element_By_URL_In_Tag, [[!--.*?\(\*F\)\|\K]],
					[[<(?!(?:img|embed|frame|iframe|object|script)[\s>])(*SKIP)(*F)|]]),
				Replace = '<!-- ********** CONTENT MASTER: Element deleted by AdMuncher. Remove images/etc with URL: \\2 -->',
				SubFind = '\\A(?=.*?(?:' .. regexp_from_list(AdMuncher_IMAGE_List) .. '))' .. AM_WL,
				On = true,
				Type = 'URL',
			})
			table.insert(v.Rules, {
				Name = '     (AdMuncher)',
				Find = [[(?=<(?>!--|s(?>cript|tyle)[\s>]))(?&html_element)(*SKIP)(*F)|]] ..
					[[(?=<img(?=\s)[^>]*?\salt=[\'"]?+([^'">]*+)(?C254))(?&html_element)]],
				Replace = '<!-- ********** CONTENT MASTER: Element deleted by AdMuncher. Remove images with "alt" text: \\1 -->',
				SubFind = regexp_from_list(AdMuncher_ALT_List),
				On = true,
			})
			table.insert(v.Rules, {
				Name = '  (AdMuncher)',
				Find = regexp_from_list(AdMuncher_REPLACE_List),
				On = true,
			})
			table.insert(v.Rules, {
				Name = ' HTML- SCRIPT    (AdMuncher)',
				Find = [[(?=<(?>!--|style[\s>]))(?&html_element)(*SKIP)(*F)|]] ..
					[[(?=<script[\s>])((?&html_element))(*SKIP)(?C254)(?:\s*+(?=<noscript[\s>])(?&html_element))?]],
				Replace = '<!-- ********** CONTENT MASTER: Element deleted by AdMuncher. Remove scripts with text -->',
				SubFind = regexp_from_list(AdMuncher_SCRIPT_List),
				On = true,
			})
			table.insert(v.Rules, {
				Name = ' HTML- FORM     (AdMuncher)',
				Find = [[(?=<(?>!--|s(?>cript|tyle)[\s>]))(?&html_element)(*SKIP)(*F)|]] ..
					[[(?=<form[\s>])((?&html_element))(*SKIP)(?C254)]],
				Replace = '<!-- ********** CONTENT MASTER: Element deleted by AdMuncher. Remove forms with text -->',
				SubFind = [[(?=<(?:!--|(?<!\A<)form[\s>]))(?&html_element)(*SKIP)(*F)|]] ..
					regexp_from_list(AdMuncher_FORM_List),
				On = true,
			})
			table.insert(v.Rules, {
				Name = ' HTML- TABLE    (AdMuncher)',
				Find = [[(?=<(?>!--|s(?>cript|tyle)[\s>]))(?&html_element)(*SKIP)(*F)|]] ..
					[[(?=<table[\s>])((?&html_element))(?C254)]],
				Replace = '<!-- ********** CONTENT MASTER: Element deleted by AdMuncher. Remove tables with text -->',
				SubFind = [[(?=<(?:!--|(?<!\A<)table[\s>]))(?&html_element)(*SKIP)(*F)|]] ..
					regexp_from_list(AdMuncher_TABLE_List),
				Order = 20,
				On = true,
			})
			table.insert(v.Rules, {
				Name = ' HTML- DIV  SPAN    (AdMuncher)',
				Find = [[(?=<(?>!--|s(?>cript|tyle)[\s>]))(?&html_element)(*SKIP)(*F)|]] ..
					[[(?=<(?:div|span)[\s>])((?&html_element))(?C254)]],
				Replace = '<!-- ********** CONTENT MASTER: Element deleted by AdMuncher. Remove divs/spans with text -->',
				SubFind = [[(?=<(?:!--|(?<!\A<)(?:div|span)[\s>]))(?&html_element)(*SKIP)(*F)|]] ..
					regexp_from_list(AdMuncher_DIV_List),
				Order = 20,
				On = true,
			})
			-- table.insert(v.Rules, {
				-- Name = '   (AdMuncher)',
				-- Find = [[(?=<(?:!--|style[\s>]))(?&html_element)(*SKIP)(*F)|(?=<script[\s>])]] ..
					--	[[((?&html_element))(?C254)(?:\s*+(?=<noscript[\s>])(?&html_element))?]],
				-- Replace = '<!-- ********** CONTENT MASTER: Element deleted by AdMuncher. Remove all popups from URL -->',
				-- SubFind = regexp_from_list(AdMuncher_POPUP_List),
				-- On = true,
			-- })
			table.insert(v.Rules, {
				Name = '  (AdMuncher)',
				Find = JS_insert,
				Replace = '\r\n\r\n<!-- AdMuncher Scripts. INSERTED BY CONTENT MASTER BEGIN: -->\r\n' ..
							 [=[<script type="text/javascript" id="__amscript_MainScript">/*<![CDATA[*/var __amscripthx,__amscriptWZ,__amscript_f;function __amscriptbE(__amscriptap,__amscriptgE,__amscriptwA){if(typeof __amscriptwA=="undefined"||__amscriptwA!=0){if(!__amscriptWZ){__amscriptWZ=1;var __amscriptf="Your browser encountered an error when executing part of the Ad Muncher helper script.  This can be caused by using a browser that is too old, so if there is a newer version of your browser please load it, and if problems persist please contact the Ad Muncher developers.\n\nError description:\n";if(__amscript_f){__amscriptf="An error occurred when executing the JavaScript filters that Ad Muncher is currently configured to use.\n\nIf you have added your own \"Add JavaScript to all pages\" filters, please check their syntax, if you have not, please contact Ad Muncher technical support.\n\nError description:\n"}if(typeof __amscriptap=="string"){__amscriptf+=__amscriptap}else if(typeof __amscriptap=="object"){__amscriptf+=__amscriptap.message.substring(0,1024);}else{__amscriptf+="N/A"}if(typeof __amscriptgE=="string"){if(typeof __amscriptwA!="undefined")__amscriptgE+=", line "+__amscriptwA;__amscriptf+="\n\nError section: "+__amscriptgE}if(typeof __amscriptIj!='undefined'){__amscriptIj(__amscriptf)}else{alert(__amscriptf)}}}return true}try{function __amscriptgv(__amscriptG,__amscriptxP){if(__amscriptG.length>__amscriptxP){__amscriptG=__amscriptG.substring(0,__amscriptxP-3)+"..."}return __amscriptG}function __amscriptvE(__amscriptG,__amscriptJh,__amscriptJL){while(__amscriptG.indexOf(__amscriptJh)!=-1){__amscriptG=__amscriptG.replace(__amscriptJh,__amscriptJL)}return __amscriptG}function __amscriptro(__amscriptG,__amscriptRg){var __amscriptTE=__amscriptG.indexOf(__amscriptRg);if(__amscriptTE!=-1){return __amscriptG.substring(0,__amscriptTE)}return __amscriptG}function __amscriptQL(__amscriptG,__amscriptdY,__amscriptBw){var __amscriptqN=__amscriptG.indexOf(__amscriptdY);if(__amscriptqN==-1)__amscriptqN=0;else __amscriptqN+=__amscriptdY.length;var __amscriptyR=__amscriptG.indexOf(__amscriptBw,__amscriptqN);if(__amscriptyR==-1)__amscriptyR=__amscriptG.length;return __amscriptG.substring(__amscriptqN,__amscriptyR)}function __amscriptpQ(__amscriptT){var __amscriptSL=0;if(__amscriptT){__amscriptSL=__amscriptvj(__amscriptT)}return __amscriptSL}function __amscriptvj(__amscriptQw){try{var __amscriptv=self;while(1){if(__amscriptLY(__amscriptv.frames,__amscriptQw)||(typeof __amscriptv.name!="undefined"&&__amscriptv.name==__amscriptQw)){return 1}if(__amscriptv==__amscriptv.parent)break;__amscriptv=__amscriptv.parent}}catch(__amscriptI){}return 0}function __amscriptLY(__amscriptve,__amscriptu){try{for(var __amscriptS=0;__amscriptS<__amscriptve.length;__amscriptS++){if(__amscriptve[__amscriptS].name==__amscriptu||__amscriptLY(__amscriptve[__amscriptS].frames,__amscriptu)){return 1}}}catch(__amscriptI){}return 0}function __amscriptGB(__amscriptu){try{var __amscriptjp=new Array('_self','_top','_main','_parent','_search','_media');for(var __amscriptS=0;__amscriptS<__amscriptjp.length;__amscriptS++){if(__amscriptu==__amscriptjp[__amscriptS]){return 1}}}catch(__amscriptI){}if(__amscriptpQ(__amscriptu)){return 1}return 0}function __amscriptDw(__amscriptu,__amscriptp){var __amscriptlD=new Array("scrollBy","getSelection","scrollByLines","scrollByPages","sizeToContent","dump","setTimeout","setInterval","clearTimeout","clearInterval","setResizable","captureEvents","releaseEvents","routeEvent","enableExternalCapture","disableExternalCapture","prompt","open","openDialog","find","alert","confirm","focus","blur","back","forward","home","stop","print","moveTo","moveBy","resizeTo","resizeBy","scroll","close","show","updateCommands","escape","unescape","atob","btoa","addEventListener","removeEventListener","dispatchEvent","getComputedStyle");var __amscripthL=new Array("captureEvents","close","open","releaseEvents","clear","writeln","getElementById","getElementsByName","elementFromPoint","createEvent","getSelection","write","createElement","createElementNS","createDocumentFragment","createTextNode","createComment","createAttribute","getElementsByTagName","importNode","attachEvent","detachEvent","hasAttributes","addEventListener","removeEventListener","dispatchEvent","contains","insertBefore","replaceChild","removeChild","appendChild","hasChildNodes","isSupported","normalize","cloneNode");var __amscriptL=new Object();for(var __amscriptKn in window){try{__amscriptL[__amscriptKn]=window[__amscriptKn]}catch(__amscriptI){}}for(var __amscriptS=0;__amscriptS<__amscriptlD.length;__amscriptS++){__amscriptL[__amscriptlD[__amscriptS]]=function(){return false}}__amscriptL.document=new Object();for(var __amscriptS=0;__amscriptS<__amscripthL.length;__amscriptS++){__amscriptL.document[__amscripthL[__amscriptS]]=function(){return false}}__amscriptL.document.body=new Object();__amscriptL.document.body.style=new Object();__amscriptL.name=__amscriptu;__amscriptL.location=new Object(__amscriptp);__amscriptL.location.href=__amscriptp;__amscriptL.location.hash=window.location.hash;__amscriptL.location.host=window.location.host;__amscriptL.location.hostname=window.location.hostname;__amscriptL.location.pathname=window.location.pathname;__amscriptL.location.port=window.location.port;__amscriptL.location.protocol=window.location.protocol;__amscriptL.location.search=window.location.search;if(typeof __amscriptTy=='undefined'){__amscriptyq=0;__amscriptTy=new Object()}__amscriptTy["w"+__amscriptyq]=__amscriptL;var __amscripts="try{__amscriptTy.w"+__amscriptyq+".closed=true;delete __amscriptTy.w"+__amscriptyq+";}catch(__amscriptI){}";if(typeof __amscriptz!='undefined'){__amscriptz(__amscripts,1500)}else{setTimeout(__amscripts,1500)}__amscriptyq++;return __amscriptL}function __amscriptvC(__amscriptq){var __amscriptct=new Array("height","width","top","left","screenx","screeny");var __amscriptki=new Array("location","toolbar","menubar","resizable","scrollbars","status","titlebar","fullscreen","directories");if(typeof __amscriptq=="string"){__amscriptq=__amscriptvE(__amscriptq.toLowerCase()," ","");if(0){for(var __amscriptS=0;__amscriptS<__amscriptct.length;__amscriptS++){__amscriptq=__amscriptvE(__amscriptq,__amscriptct[__amscriptS]+"=","blocked=")}}if(0){for(var __amscriptS=0;__amscriptS<__amscriptki.length;__amscriptS++){__amscriptq=__amscriptvE(__amscriptq,__amscriptki[__amscriptS]+"=","blocked=")}}}if(0){if(typeof __amscriptq=="string")__amscriptq+=", ";else __amscriptq="";__amscriptq+="location, toolbar, menubar, resizable, scrollbars, status, titlebar, directories"}return __amscriptq}function __amscriptcX(){try{var __amscriptA=window;while(1){__amscripth=__amscriptA.event;if(__amscriptTZ(__amscripth))return;if(!__amscriptA.parent||__amscriptA==__amscriptA.parent){break}__amscriptA=__amscriptA.parent}}catch(__amscriptI){}__amscripth=__amscriptYX()}function __amscriptYX(){try{var __amscriptmv=arguments.callee.caller;for(var __amscriptcE=0;__amscriptcE++<20&&__amscriptmv;){if(__amscriptmv.arguments.length==1){var __amscriptst=__amscriptmv.arguments[0];if(typeof __amscriptst=='object'&&__amscriptTZ(__amscriptst)){return __amscriptst}}__amscriptmv=__amscriptmv.caller}}catch(__amscriptI){}var __amscriptxk=new Object();__amscriptxk.type="";return __amscriptxk}function __amscriptTZ(__amscriptF){if(__amscriptF&&typeof __amscriptF=='object'&&typeof __amscriptF.type=='string'){var __amscriptxc=0;var __amscriptuI=new Array("altKey","ctrlKey","shiftKey","button","cancelBubble","clientX","clientY","fromElement","toElement","srcElement","target","returnValue","preventDefault");for(var __amscriptS=0;__amscriptS<__amscriptuI.length;__amscriptS++){var __amscriptpu=__amscriptuI[__amscriptS];if(typeof __amscriptF[__amscriptpu]!='undefined'){if(++__amscriptxc>=2){return 1}}}}return 0}function __amscriptc(__amscriptGY){__amscriptcX();if(__amscripth.type!=""){var __amscriptFo=__amscripth.type.toLowerCase();for(var __amscriptS=0;__amscriptS<__amscriptGY.length;__amscriptS++){if(__amscriptFo==__amscriptGY[__amscriptS]){return 1}}}return 0}function __amscriptUa(){if(1==1){__amscriptcX();if(typeof __amscripth.ctrlKey!='undefined'&&__amscripth.ctrlKey==1&&(typeof __amscripth.altKey=='undefined'||__amscripth.altKey==0)&&(typeof __amscripth.shiftKey=='undefined'||__amscripth.shiftKey==0)){return 1}}return 0}function __amscriptUy(__amscriptQ,__amscriptM){if(typeof __amscriptM!="function")__amscriptM=new Function(__amscriptM);if(typeof __amscriptw[__amscriptQ]=='undefined'){__amscriptw[__amscriptQ]=new Array();if(__amscriptQ!='DOMContentLoaded'&&__amscriptQ!='amfc'){__amscriptBi(__amscriptQ,new Function("__amscriptYy","if(arguments.length>=1)__amscriptMY(\""+__amscriptQ+"\", __amscriptYy);"+"else __amscriptMY(\""+__amscriptQ+"\");"))}}__amscriptw[__amscriptQ][__amscriptw[__amscriptQ].length]=__amscriptM}function __amscriptBi(__amscriptQ,__amscriptM){if(typeof __amscriptM!="function")__amscriptM=new Function(__amscriptM);if(typeof window.addEventListener!="undefined"){if(typeof window.__amscriptP!='undefined'){window.__amscriptP(__amscriptQ,__amscriptM,false)}else{window.addEventListener(__amscriptQ,__amscriptM,false)}}else if(typeof document.addEventListener!="undefined"){if(typeof document.__amscriptP!='undefined'){document.__amscriptP(__amscriptQ,__amscriptM,false)}else{document.addEventListener(__amscriptQ,__amscriptM,false)}}else{__amscriptQ="on"+__amscriptQ;if(typeof window.attachEvent!="undefined"){if(typeof window.__amscriptt!='undefined'){window.__amscriptt(__amscriptQ,__amscriptM)}else{window.attachEvent(__amscriptQ,__amscriptM)}if(typeof document.__amscriptt!='undefined'){document.__amscriptt(__amscriptQ,__amscriptM)}else{document.attachEvent(__amscriptQ,__amscriptM)}}else{if(typeof window[__amscriptQ]=='undefined'){window[__amscriptQ]=__amscriptM}if(typeof document[__amscriptQ]=='undefined'){document[__amscriptQ]=__amscriptM}}}}function __amscriptMY(__amscriptQ,__amscriptYy){if(typeof __amscriptw[__amscriptQ]!='undefined'){var __amscriptrS=__amscriptw[__amscriptQ];if(arguments.length>=2){for(var __amscriptS=0;__amscriptS<__amscriptrS.length;__amscriptS++){__amscriptrS[__amscriptS](__amscriptYy)}}else{for(var __amscriptS=0;__amscriptS<__amscriptrS.length;__amscriptS++){__amscriptrS[__amscriptS]()}}}}function __amscriptgr(){if(typeof __amscriptOm!='undefined'){__amscriptSY();if(__amscriptOm++==1){__amscriptMY("DOMContentLoaded")}}}function __amscriptWW(__amscriptlW,__amscriptb){if(typeof __amscripto=='undefined'){__amscripto=new Object()}if(typeof __amscripto[__amscriptlW]=='undefined'){__amscripto[__amscriptlW]=new Array()}__amscripto[__amscriptlW][__amscripto[__amscriptlW].length]=__amscriptb;__amscriptGF();__amscriptkj();__amscriptGr();__amscriptoL=__amscriptaa()}function __amscriptTb(__amscriptx){var __amscriptvJ="";if(typeof __amscripto!='undefined'){for(var __amscriptS=0;__amscriptS<__amscriptx.length;__amscriptS++){var __amscriptK=__amscriptx[__amscriptS];if(typeof __amscripto[__amscriptK]!='undefined'){var __amscriptAG=__amscripto[__amscriptK].length;if(__amscriptAG>0){if(__amscriptvJ!=""){__amscriptvJ+=" and "}__amscriptvJ+=__amscriptAG+" "+__amscriptK;if(__amscriptAG>1){__amscriptvJ+="s"}}}}}return __amscriptvJ}function __amscriptVI(__amscriptx){var __amscriptem="";if(typeof __amscripto!='undefined'){for(var __amscriptS=0;__amscriptS<__amscriptx.length;__amscriptS++){var __amscriptK=__amscriptx[__amscriptS];if(typeof __amscripto[__amscriptK]!='undefined'){for(var __amscriptkm=0;__amscriptkm<__amscripto[__amscriptK].length;__amscriptkm++){if(__amscriptem!=""){__amscriptem+=", "}__amscriptem+=__amscriptWV(__amscripto[__amscriptK][__amscriptkm])}}}}return __amscriptem}function __amscriptWV(__amscriptb){__amscriptb=__amscriptgv(__amscriptb,64);__amscriptb='"'+__amscriptb+'"';return __amscriptb}function __amscriptGF(){__amscriptia=__amscriptVg="";if(1){var __amscriptx=new Array('alert message','popup');var __amscriptne=__amscriptVI(__amscriptx);if(__amscriptne!=""){var __amscriptCj=__amscriptTb(__amscriptx);__amscriptVg=__amscriptCj+" blocked by Ad Muncher: "+__amscriptne;__amscriptia=__amscriptCj+" blocked by Ad Muncher"}}}function __amscriptGr(){try{var __amscriptU=top.document.title;if(__amscriptU.indexOf(" blocked by Ad Muncher")!=-1){var __amscriptzy=__amscriptU.lastIndexOf(" - ");if(__amscriptzy!=-1){__amscriptU=__amscriptU.substring(0,__amscriptzy)}else if(__amscriptU.charAt(0)>='0'&&__amscriptU.charAt(0)<='9'){__amscriptU=""}}if(__amscriptia!=""){__amscriptU=__amscriptgv(__amscriptU,75);if(__amscriptU!=""){__amscriptU+=" - "}__amscriptU+=__amscriptia}if(top.document.title!=__amscriptU){top.document.title=__amscriptU}}catch(__amscriptI){}}function __amscriptlX(){__amscriptUy("unload",__amscriptBR);__amscriptUy("load",__amscriptgr);__amscriptBi("mouseover",__amscriptqi);__amscriptBi("mouseout",__amscriptqi);__amscriptBi("DOMContentLoaded",__amscriptgr)}function __amscriptSc(__amscriptJ){var __amscriptpH=new Array('open','showHelp','showModalDialog','showModelessDialog','createPopup','alert','blur','focus','moveTo','moveBy','resizeTo','resizeBy','setTimeout','setInterval','clearTimeout','clearInterval','addEventListener','attachEvent');var __amscriptGl=new Array('__amscriptAO','__amscriptTG','__amscriptgC','__amscriptka','__amscripthy','__amscriptKU','__amscriptTp','__amscriptxJ','__amscriptXv','__amscriptxw','__amscriptca','__amscriptMg','__amscriptkp','__amscriptAo','__amscriptDn','__amscriptwM','__amscriptVz','__amscriptVP');var __amscriptyV=new Array('__amscriptfc','__amscriptqT','__amscriptZt','__amscriptCT','__amscriptd','__amscriptIj','__amscriptjN','__amscriptiZ','__amscripttA','__amscriptue','__amscriptiC','__amscriptuU','__amscriptz','__amscriptbz','__amscriptEB','__amscriptHy','__amscriptP','__amscriptt');var __amscriptUU=new Array('addEventListener','attachEvent');var __amscriptcR=new Array('__amscriptVz','__amscriptVP');var __amscripthz=new Array('__amscriptP','__amscriptt');for(var __amscriptS=0;__amscriptS<__amscriptpH.length;__amscriptS++){__amscriptdm(__amscriptJ,__amscriptpH[__amscriptS],window[__amscriptGl[__amscriptS]],__amscriptyV[__amscriptS])}try{if(typeof __amscriptJ.document!='undefined'){for(var __amscriptS=0;__amscriptS<__amscriptUU.length;__amscriptS++){__amscriptdm(__amscriptJ.document,__amscriptUU[__amscriptS],window[__amscriptcR[__amscriptS]],__amscripthz[__amscriptS])}}}catch(__amscriptI){}return __amscriptJ}function __amscriptdm(__amscriptoR,__amscriptm,__amscriptM,__amscriptLl){try{if(typeof __amscriptII[__amscriptm]=='undefined'){if(typeof __amscriptoR[__amscriptm]!='undefined'){if(typeof __amscriptoR[__amscriptLl]=="undefined"){__amscriptoR[__amscriptLl]=__amscriptoR[__amscriptm]}__amscriptoR[__amscriptm]=__amscriptM}}}catch(__amscriptI){}}function __amscriptqi(__amscriptF){__amscriptF=__amscriptF||event;var __amscriptD=__amscriptF.target||__amscriptF.srcElement;__amscriptrK="";__amscriptD=__amscriptIG(__amscriptD);if(__amscriptD){var __amscriptYl=__amscriptbu(__amscriptD.href);if(__amscriptYl){__amscriptD.href=__amscriptYl}__amscriptrK=__amscriptD.href}__amscriptkj()}function __amscriptQK(){var __amscriptN=0;if(0||(__amscriptVg!=""&&__amscriptrK=="")){if(__amscriptrK!=""){__amscriptN=__amscriptrK}else{__amscriptN=__amscriptVg}__amscriptN=__amscriptN}return __amscriptN}function __amscriptYI(){var __amscriptN=__amscriptQK();if(__amscriptN!==0){window.status=window.defaultStatus=__amscriptN}}function __amscriptkj(){__amscriptYI();if(__amscriptuk==0){__amscriptuk++;if(typeof __amscriptz!='undefined'){__amscriptz(__amscriptKE,0)}else{setTimeout(__amscriptKE,0)}}}function __amscriptKE(){try{__amscriptYI();__amscriptuk=0}catch(__amscriptI){}}function __amscriptIG(__amscriptC){try{while(__amscriptC){if(__amscriptC.tagName){if(__amscriptC.tagName.toLowerCase()=='a'){return __amscriptC}}__amscriptC=__amscriptC.parentNode}}catch(__amscriptI){}return 0}function __amscriptbu(__amscriptB){if(__amscriptB&&__amscriptB.toLowerCase().indexOf("javascript")!=-1&&__amscriptB.indexOf("__amscriptNP")==-1){if(typeof __amscriptgf=='undefined'){var __amscriptBE="javascript:";var __amscriptCt="javascript:if(typeof __amscriptNP==typeof alert)__amscriptNP();";window.__amscriptgf=new Array();window.__amscriptzX=new Array();for(var __amscriptS=0;__amscriptS<2;__amscriptS++){__amscriptgf[__amscriptS]=new RegExp(__amscriptBE,"gi");__amscriptzX[__amscriptS]=__amscriptCt;__amscriptBE=escape(__amscriptBE);__amscriptCt=escape(__amscriptCt)}}for(var __amscriptS=0;__amscriptS<__amscriptgf.length;__amscriptS++){__amscriptB=__amscriptB.replace(__amscriptgf[__amscriptS],__amscriptzX[__amscriptS])}return __amscriptB}return""}function __amscriptNP(){__amscripta=1;if(typeof __amscriptz!='undefined')__amscriptz("__amscripta=0",0);else setTimeout("__amscripta=0",0)}function __amscriptpE(__amscriptBM){__amscriptcX();var __amscriptD=__amscripth.target||__amscripth.srcElement;__amscriptD=__amscriptIG(__amscriptD);if(__amscriptD){try{if(__amscriptD.href==__amscriptBM)return 1}catch(__amscriptI){}try{for(var __amscriptqB in __amscriptD){if(__amscriptD[__amscriptqB]==__amscriptBM)return 1}}catch(__amscriptI){}}return 0}function __amscriptYf(){__amscriptcX();var __amscriptgW="on"+__amscripth.type.toLowerCase();var __amscriptD=__amscripth.target||__amscripth.srcElement;while(__amscriptD){if(__amscriptD.tagName&&__amscriptD.tagName.toLowerCase()!='body'&&__amscriptD[__amscriptgW]){return 0}__amscriptD=__amscriptD.parentNode}return 1}function __amscriptZP(__amscriptvI,__amscriptJ,__amscriptp){if(__amscriptvI>0){try{__amscriptJ.blur=__amscriptJ.close}catch(__amscriptI){}}var __amscriptHb=new Object();__amscriptHb.__amscriptHY=__amscriptJ;__amscriptHb.__amscriptKy=__amscriptp;__amscriptHb.__amscriptCm=__amscriptvI;__amscriptl["p"+__amscriptJG]=__amscriptHb;var __amscripts="try{delete __amscriptl.p"+__amscriptJG+";}catch(__amscriptI){}";if(typeof __amscriptz!='undefined'){__amscriptz(__amscripts,2000)}else{setTimeout(__amscripts,2000)}__amscriptJG++}function __amscriptSY(){var __amscripts="try{__amscriptVb=1;__amscriptGI();__amscriptNa();}catch(__amscriptI){}";if(typeof __amscriptz!='undefined'){__amscriptz(__amscripts,50)}else{setTimeout(__amscripts,50)}}function __amscriptma(__amscriptvI){for(var __amscriptS in __amscriptl){try{if(__amscriptl[__amscriptS].__amscriptCm>=__amscriptvI){var __amscripty=__amscriptDJ(__amscriptl[__amscriptS].__amscriptKy);if(!__amscriptvo(__amscripty,"__amscriptfw")){__amscriptl[__amscriptS].__amscriptHY.close()}delete __amscriptl[__amscriptS]}}catch(__amscriptI){}}}function __amscriptBR(){__amscriptma(2)}function __amscriptVz(__amscriptQ,__amscriptM,__amscriptYb){if(__amscriptnZ(__amscriptQ))return;if(arguments.length>=3)this.__amscriptP(__amscriptQ,__amscriptM,__amscriptYb);else if(arguments.length>=2)this.__amscriptP(__amscriptQ,__amscriptM);else if(arguments.length>=1)this.__amscriptP(__amscriptQ);else this.__amscriptP();}function __amscriptVP(__amscriptQ,__amscriptM){if(__amscriptnZ(__amscriptQ))return true;else if(arguments.length>=2)return this.__amscriptt(__amscriptQ,__amscriptM);else if(arguments.length>=1)return this.__amscriptt(__amscriptQ);else return this.__amscriptt();}function __amscriptnZ(__amscriptQ){try{var __amscriptE=__amscriptRU();__amscriptQ=__amscriptQ.toLowerCase();if(__amscriptQ.substring(0,2)=='on'){__amscriptQ=__amscriptQ.substring(2)}for(var __amscriptS=0;__amscriptS<__amscriptE.length;__amscriptS++){if(__amscriptQ==__amscriptE[__amscriptS]){return 1}}}catch(__amscriptI){}return 0}function __amscriptRU(){var __amscriptXI=new Array();if(__amscript_smi){__amscriptXI=new Array('copy','selectstart','contextmenu','dragstart','click','mousedown','mouseup')}return __amscriptXI}function __amscriptNa(){try{var __amscriptE=__amscriptRU();__amscriptdF(window,__amscriptE);if(typeof document!='undefined'){__amscriptdF(document,__amscriptE)}if(typeof document.body!='undefined'){__amscriptdF(document.body,__amscriptE)}}catch(__amscriptI){}}function __amscriptuM(){return true}function __amscriptdF(__amscriptJ,__amscriptnU){for(var __amscriptS=0;__amscriptS<__amscriptnU.length;__amscriptS++){if(typeof __amscriptJ["on"+__amscriptnU[__amscriptS]]=='function'){__amscriptJ["on"+__amscriptnU[__amscriptS]]=__amscriptuM}}}function __amscriptAO(__amscriptp,__amscriptu,__amscriptq,__amscripthC){var __amscriptX=__amscriptOl(__amscriptp,__amscriptu);if(__amscriptX==3){return __amscriptDw(__amscriptu,__amscriptp)}__amscriptq=__amscriptvC(__amscriptq);var __amscriptk;if(arguments.length>=4)__amscriptk=this.__amscriptfc('',__amscriptu,__amscriptq,__amscripthC);else if(arguments.length>=3)__amscriptk=this.__amscriptfc('',__amscriptu,__amscriptq);else if(arguments.length>=2)__amscriptk=this.__amscriptfc('',__amscriptu);else if(arguments.length>=1)__amscriptk=this.__amscriptfc('');else __amscriptk=this.__amscriptfc();__amscriptSc(__amscriptk);__amscriptZP(__amscriptX,__amscriptk,__amscriptp);if(arguments.length>=1){__amscriptk.location.href=__amscriptp}return __amscriptk};function __amscriptTG(__amscriptp,__amscriptLv){if(__amscriptOl(__amscriptp)==3)return;if(arguments.length>=2)this.__amscriptqT(__amscriptp,__amscriptLv);else if(arguments.length>=1)this.__amscriptqT(__amscriptp);else this.__amscriptqT();};function __amscriptgC(__amscriptp,__amscriptY,__amscriptq){var __amscriptX=__amscriptOl(__amscriptp);if(__amscriptX==3)return 0;if(arguments.length>=3)return this.__amscriptZt(__amscriptp,__amscriptY,__amscriptq);else if(arguments.length>=2)return this.__amscriptZt(__amscriptp,__amscriptY);else if(arguments.length>=1)return this.__amscriptZt(__amscriptp);else return this.__amscriptZt()};function __amscriptka(__amscriptp,__amscriptY,__amscriptq){var __amscriptX=__amscriptOl(__amscriptp);if(__amscriptX==3){return __amscriptDw("",__amscriptp)}var __amscriptk;if(arguments.length>=3)__amscriptk=this.__amscriptCT('',__amscriptY,__amscriptq);else if(arguments.length>=2)__amscriptk=this.__amscriptCT('',__amscriptY);else if(arguments.length>=1)__amscriptk=this.__amscriptCT('');else __amscriptk=this.__amscriptCT();__amscriptSc(__amscriptk);__amscriptZP(__amscriptX,__amscriptk,__amscriptp);if(arguments.length>=1){__amscriptk.location.href=__amscriptp}return __amscriptk};function __amscripthy(__amscriptZ,__amscriptcS,__amscriptoO,__amscriptpS,__amscripttN,__amscriptJS){var __amscriptX=__amscriptOl();if(__amscriptX==3){return __amscriptDw("","")}var __amscriptk;if(arguments.length>=6)__amscriptk=this.__amscriptd(__amscriptZ,__amscriptcS,__amscriptoO,__amscriptpS,__amscripttN,__amscriptJS);else if(arguments.length>=5)__amscriptk=this.__amscriptd(__amscriptZ,__amscriptcS,__amscriptoO,__amscriptpS,__amscripttN);else if(arguments.length>=4)__amscriptk=this.__amscriptd(__amscriptZ,__amscriptcS,__amscriptoO,__amscriptpS);else if(arguments.length>=3)__amscriptk=this.__amscriptd(__amscriptZ,__amscriptcS,__amscriptoO);else if(arguments.length>=2)__amscriptk=this.__amscriptd(__amscriptZ,__amscriptcS);else if(arguments.length>=1)__amscriptk=this.__amscriptd(__amscriptZ);else __amscriptk=this.__amscriptd();__amscriptSc(__amscriptk);__amscriptZP(__amscriptX,__amscriptk,"");return __amscriptk};function __amscriptKU(__amscriptNi){if(__amscriptuD()==0||__amscriptNi.indexOf("Ad Muncher")!=-1){this.__amscriptIj(__amscriptNi)}else{__amscriptWW("alert message",__amscriptvE(__amscriptNi,"\n"," "))}};function __amscriptTp(){if(!0){this.__amscriptjN()}};function __amscriptxJ(){if(this==window){__amscriptma(1)}if(!0){this.__amscriptiZ()}};function __amscriptXv(__amscriptV,__amscriptj){if(!0){this.__amscripttA(__amscriptV,__amscriptj)}};function __amscriptxw(__amscriptV,__amscriptj){if(!0){this.__amscriptue(__amscriptV,__amscriptj)}};function __amscriptca(__amscriptV,__amscriptj){if(!0){this.__amscriptiC(__amscriptV,__amscriptj)}};function __amscriptMg(__amscriptV,__amscriptj){if(!0){this.__amscriptuU(__amscriptV,__amscriptj)}};function __amscriptkp(__amscriptn,__amscriptZR,__amscriptOY){var __amscripti;if(!__amscriptH)__amscriptH=0;var __amscriptOZ="t"+(__amscriptH++);var __amscriptr=__amscriptbK(__amscriptOZ,__amscriptn,1);if(arguments.length>=3)__amscripti=this.__amscriptz(__amscriptr,__amscriptZR,__amscriptOY);else if(arguments.length>=2)__amscripti=this.__amscriptz(__amscriptr,__amscriptZR);else if(arguments.length>=1)__amscripti=this.__amscriptz(__amscriptr);else __amscripti=this.__amscriptz();__amscriptR[__amscriptOZ].__amscripti=__amscripti;return __amscripti};function __amscriptAo(__amscriptn,__amscriptZR,__amscriptOY){var __amscripti;if(!__amscriptH)__amscriptH=0;var __amscriptOZ="i"+(__amscriptH++);var __amscriptr=__amscriptbK(__amscriptOZ,__amscriptn,0);if(arguments.length>=3)__amscripti=this.__amscriptbz(__amscriptr,__amscriptZR,__amscriptOY);else if(arguments.length>=2)__amscripti=this.__amscriptbz(__amscriptr,__amscriptZR);else if(arguments.length>=1)__amscripti=this.__amscriptbz(__amscriptr);else __amscripti=this.__amscriptbz();__amscriptR[__amscriptOZ].__amscripti=__amscripti;return __amscripti};function __amscriptGU(__amscriptg,__amscriptKu){try{for(var __amscriptS in __amscriptR){if(__amscriptS.charAt(0)==__amscriptKu){var __amscriptHn=__amscriptR[__amscriptS];if(typeof __amscriptHn.__amscripti!='undefined'&&__amscriptHn.__amscripti==__amscriptg){delete __amscriptR[__amscriptS]}}}}catch(__amscriptI){}}function __amscriptwM(__amscriptg){__amscriptGU(__amscriptg,'i');this.__amscriptHy(__amscriptg)};function __amscriptDn(__amscriptg){__amscriptGU(__amscriptg,'t');this.__amscriptEB(__amscriptg)};function __amscriptbK(__amscriptRT,__amscriptn,__amscriptzx){var __amscriptNB=__amscriptn+"";if(__amscriptNB.indexOf("__amscripttb();")==-1){if(typeof __amscriptn!="function")__amscriptn=new Function(__amscriptn);var __amscriptHn=new Object();__amscriptHn.__amscriptsa=__amscriptn;__amscriptR[__amscriptRT]=__amscriptHn;__amscriptn="__amscriptTL('"+__amscriptRT+"',"+__amscriptzx+");"}return __amscriptn}function __amscriptaa(){var __amscripte=new Object();try{__amscripte.__amscriptLg=window.status}catch(__amscriptI){__amscripte.__amscriptLg=0}try{__amscripte.__amscriptwx=window.defaultStatus}catch(__amscriptI){__amscripte.__amscriptwx=0}try{__amscripte.__amscriptUQ=top.document.title}catch(__amscriptI){__amscripte.__amscriptUQ=0}return __amscripte}function __amscriptGI(){var __amscripttM=__amscriptaa();var __amscriptN=0;if(__amscriptoL.__amscriptLg!==__amscripttM.__amscriptLg){__amscriptN=__amscriptQK();if(__amscriptN!==0)window.status=__amscriptN}if(__amscriptoL.__amscriptwx!==__amscripttM.__amscriptwx){if(__amscriptN===0){__amscriptN=__amscriptQK()}if(__amscriptN!==0)window.defaultStatus=__amscriptN}if(__amscriptoL.__amscriptUQ!==__amscripttM.__amscriptUQ){__amscriptGr()}}function __amscriptTL(__amscriptRT,__amscriptzx){__amscriptoL=__amscriptaa();__amscriptKd=1;try{this.__amscriptpP=__amscriptR[__amscriptRT].__amscriptsa;this.__amscriptpP();this.__amscriptpP="";}catch(__amscriptI){}__amscriptKd=0;if(__amscriptzx){delete __amscriptR[__amscriptRT]}__amscriptGI()}function __amscriptvo(__amscriptDB,__amscriptwW){var __amscriptuX=new Object();__amscriptuX.__amscriptfw=new Array('.alawar.ru/download/','.bigseagames.','.dhl.de/nextt-','.edu.au/infonet/','.extjs.com/deploy/','.facebook.com/login.','.facebook.com/sharer.','.gamespot.com/pages/','.gmx.com/mail/','.google.com/mail/','.gov/funzone/','.latinchat.com/lg/','.me.com/idisk/','.packers.com/multimedia/','.php?i=pm&','.sears.com/is/','.tudou.com/isearch/','.usda.gov/e-work/','.usps.gov/popups/','/ccc?','/chatplus.html?','/detect.htm','/docaction?','/emailthis?','/flight?code=','/img_popup.jsp?','/instorepickup.','/js/push/lsengine.','/manualpopup?','/msgpopup.php?s=','/newform?','/nidlogin.','/playerinfo.html?','/public/logon.do','/signin/home?','/spurl.php?v=','/ssprint.aspx?','/templates?','/video/*/offsite','_game.php?pid=','isapi.dll?picture','about:help');__amscriptuX.__amscriptmO=new Array('.bing.com/*/popups/','.code-server.','.drevil.','.firstload.de','.gulli.com/vote/','.marketgid.','.megaclick.com/ad.','.my-downloads.','.mydirtyhobby.com/?','.rockyou.com/ams/','.xloadz.com','/b/3c--','/enterpopup.','_popunder.','www.uff5.to');var __amscriptBO,__amscriptQh,__amscriptW;__amscriptW=__amscriptro(__amscriptDB,"#");if(__amscriptW=="No URL"){__amscriptW=__amscriptDB}__amscriptW+=" "+document.URL;__amscriptW=__amscriptW.toLowerCase();for(var __amscriptxg=0;__amscriptxg<__amscriptuX[__amscriptwW].length;__amscriptxg++){__amscriptBO=-1;__amscriptQh=__amscriptuX[__amscriptwW][__amscriptxg].split("*");for(var __amscriptek=0;__amscriptek<__amscriptQh.length;__amscriptek++){__amscriptBO=__amscriptW.indexOf(__amscriptQh[__amscriptek],__amscriptBO);if(__amscriptBO==-1)break}if(__amscriptBO>=0){return 1}}return 0}function __amscripthj(__amscriptT,__amscriptp){if(__amscriptGB(__amscriptT))return 0;if(__amscriptUa())return 0;if(0==1)return 3;if(__amscriptvo(__amscriptp,"__amscriptmO"))return 3;if(__amscriptvo(window.location.href,"__amscriptmO"))return 3;if(1==0)return 0;if(__amscriptc(new Array("load","unload","beforeunload","mousemove","mouseout","mouseover","select")))return 3;if(typeof __amscripta!='undefined'&&__amscripta==1)return 1;if(__amscriptc(new Array("dragdrop","error")))return 1;if(__amscriptc(new Array("change","click","dblclick","blur","keydown","keyup","mousedown","mouseup","submit"))){if(__amscriptYf()&&(__amscriptp==""||__amscriptpE(__amscriptp)==0)){return 3}else{return 2}}if(!__amscriptVb)return 3;if(__amscriptKd)return 3;return 1}function __amscriptuD(){if(__amscriptUa())return 0;if(1==0)return 0;if(__amscriptc(new Array("load","unload","beforeunload","mousemove","mouseout","mouseover","select")))return 1;if(typeof __amscripta!='undefined'&&__amscripta==1)return 0;if(__amscriptc(new Array("dragdrop","error")))return 0;if(__amscriptc(new Array("change","click","dblclick","blur","keydown","keyup","mousedown","mouseup","submit"))){if(__amscriptYf()){return 1}else{return 0}}if(!__amscriptVb)return 1;if(__amscriptKd)return 1;return 0}function __amscriptOl(__amscriptp,__amscriptT){var __amscriptX=__amscripthj(__amscriptT,__amscriptp);if(__amscriptX<3){return __amscriptX}var __amscripty=__amscriptDJ(__amscriptp);var __amscriptNJ=(__amscripty=='No URL')?__amscriptp:__amscripty;if(__amscriptvo(__amscriptNJ,"__amscriptfw")){return 0}__amscriptWW("popup",__amscripty);return 3}function __amscriptDJ(__amscriptp){var __amscripty,__amscriptpR;var __amscriptBI=new Image();if(__amscriptp){if(__amscriptp.search(/[A-Za-z]+:/)!=-1){if(__amscriptp.substring(0,5).toLowerCase()!="http:"){return"No URL"}}__amscriptpR="/admuncherpopcheck&"+Math.random()+"&"+document.URL;__amscriptBI.src=__amscriptro(__amscriptp,"#")+__amscriptpR;__amscripty=__amscriptro(__amscriptBI.src,"/admuncherpopcheck&")}else{__amscripty="No URL";__amscriptpR="/admuncherpopchecknourl&"+Math.random();__amscriptBI.src=document.URL+__amscriptpR}if(typeof __amscriptWt=='undefined'){__amscriptWt=new Object();__amscriptna=0}__amscriptWt['i'+__amscriptna]=__amscriptBI;var __amscripts="try{delete __amscriptWt.i"+__amscriptna+";}catch(__amscriptI){}";if(typeof __amscriptz!='undefined'){__amscriptz(__amscripts,10000)}else{setTimeout(__amscripts,10000)}__amscriptna++;return __amscripty}if(self.__amscripthx!=1){self.__amscripthx=1;var __amscript_smi=0,__amscriptH=0,__amscriptR=new Object(),__amscriptJG=0,__amscriptl=new Object(),__amscriptw=new Object(),__amscriptII=new Object(),__amscriptVb=0,__amscriptKd=0,__amscriptrK="",__amscriptVg="",__amscriptuk=0,__amscriptoL=__amscriptaa(),__amscript_addonload=function(__amscriptO){__amscriptUy("load",__amscriptO)},__amscript_addunonload=function(__amscriptO){__amscriptUy("unload",__amscriptO)},__amscript_trapevent=function(__amscriptQ,__amscriptO){__amscriptUy(__amscriptQ,__amscriptO)},__amscript_donttrap=function(__amscriptm){__amscriptII[__amscriptm]=1},__amscript_f=1;try{]=] ..
							 table.concat(AdMuncher_JS_List, '__amscript_f++;') ..
							 [=[}catch(__amscriptI){if(__amscript_f>=1000000){__amscriptbE(__amscriptI,"User filter #"+(__amscript_f-1000000))}else{__amscriptbE(__amscriptI,"Server filter #2785-"+__amscript_f+", please report this to the Ad Muncher developers.")}}__amscript_f=0;__amscriptlX();__amscriptSc(window);if(navigator.appName=='Microsoft Internet Explorer'&&!window.opera){document.write('<scr'+'ipt type="text/javascript" defer="defer" src="//:" onreadystatechange="(function(element){if(element.readyState===\'complete\')__amscriptgr();})(this);"></scr'+'ipt>')}if(1){window.onerror=function(){return 1}}}}catch(__amscriptI){__amscriptbE(__amscriptI,"Main helper code block")}/*]]>*/</script><script type="text/javascript">/*<![CDATA[*/var __amscriptOm=1;/*]]>*/</script>]=] ..
							 '\r\n<!-- AdMuncher Scripts. INSERTED BY CONTENT MASTER END -->\r\n\r\n',
				Counted = false,
				Once = true,
				Order = 30,
				On = true,
			})
			v.Rules[#v.Rules].Replace = v.Rules[#v.Rules].Replace:gsub('__amscript', 'XZwY')
			table.insert(v.Rules, {
				Name = '  CSS (AdMuncher)',
				Find = CSS_insert,
				Replace = '\r\n<!-- AdMuncher CSS rules. INSERTED BY CONTENT MASTER BEGIN: -->\r\n' ..
							 '<style type="text/css">\r\n' .. table.concat(AdMuncher_CSS_List, '\r\n') ..
							 '\r\n</style>\r\n<!-- AdMuncher CSS rules. INSERTED BY CONTENT MASTER END -->\r\n\r\n',
				Counted = false,
				Once = true,
				Order = 30,
				On = true,
			})
		end
-- ---------------------------   Adblock -----------------------
	elseif v.Type=='AdBlockPlus' then
		v.File = re.find(sfile, [[AdBlockPlus files=\K.+?$]]) or 'adblock.txt, easylist.txt, easyprivacy.txt'
		local AdBlockPlus_Black_List = {}
		local AdBlockPlus_White_List = {}
		local AdBlockPlus_CSS_List = {}
		local AdBlockPlus_CSS_With_Domain_List = {}
		local AdBlockPlus_Request_White_List = Global_Request_White_List
		local AdBlockPlus_Request_Black_List = Global_Request_Black_List
		for file in string.gmatch(v.File, '[^, ]+') do	--     
			local f, err = io.open(re.replace(hc.script_name, [[\\[^\\]+$]], [[\]]) .. file, 'rb')
			if f then
				f:close()
				if v.On then
					for line in io.lines(re.replace(hc.script_name, [[\\[^\\]+$]], [[\]]) .. file) do
						local regexp = re.find(line, [[^(?|(?:@@)?/(.*)/|(?![![])(?:@@)?([^$#]*+))(?:$|\$(.+))]], 1)
						if regexp then		--     URL
							local opts = re.substr(2) or ''
							--   AdBlockPlus  " "  
							if not re.match(nil, [[^(?:@@)?/.*/($|\$)]]) then
								regexp = toregexp(regexp)
								--  ('^'),   AdBlockPlus 1.1
								regexp = regexp:gsub('\\%^', [[(?:[^\w.%%-]|_|$)]])
								regexp = regexp:gsub('^\\|\\|', [[^https?://(?:[^/?]*?\.)?]], 1)
								regexp = regexp:gsub('^\\|', '^', 1)
								regexp = regexp:gsub('\\|$', '$', 1)
							end
							local type_options = {
								stylesheet=[[^link(?=\s).*?\srel=[\'"]?+stylesheet[\'"]?+(?:\s|/?\z)]],
								['~stylesheet']=[[^(?!link(?=\s).*?\srel=[\'"]?+stylesheet[\'"]?+(?:\s|/?\z))]],
								image=[[^img(?:\s|\z)]], ['~img']=[[^(?!img(?:\s|\z))]],
								script=[[^script(?:\s|\z)]], ['~script']=[[^(?!script(?:\s|\z))]],
								object=[[^object(?:\s|\z)]], ['~object']=[[^(?!object(?:\s|\z))]],
								subdocument=[[^(?:i?frame|object)(?:\s|\z)]],
								['~subdocument']=[[^(?!(?:i?frame|object)(?:\s|\z))]],
								ping=[[^(?>a(?:rea)?|link)(?=\s).*?\sping=]],
								['~ping']=[[^(?!(?>a(?:rea)?|link)(?=\s).*?\sping=)]]
								-- other='^(?!(?:link|img|script|object|i?frame)$)',
								-- ['~other']='^(?:link|img|script|object|i?frame)$',
							}
							for option in opts:gmatch('[^,]+') do		--  
								local domains = re.find(option, [[^domain=\K.+]])
								if domains then
									local lst, neg_lst = {}, {}
									for current_domain in domains:gmatch('[^|]+') do
										table.insert(current_domain:find('^~') and neg_lst or lst,
											toregexp(re.find(current_domain, [[^~?+\K.+]])))
									end
									if lst[1] then
										regexp = [[^(?=\w+:(?://)?[^?:/]*?]] ..
											brackets_if_toplevel_alts(table.concat(lst, '|')) .. ').*?' ..
											brackets_if_toplevel_alts(regexp)
									end
									if neg_lst[1] then
										regexp = [[^(?!\w+:(?://)?[^?:/]*?]] ..
											brackets_if_toplevel_alts(table.concat(neg_lst, '|')) .. ').*?' ..
											brackets_if_toplevel_alts(regexp)
									end
								elseif option == 'match-case' then
									regexp = '(?-i:' .. regexp .. ')'
								elseif option == 'third-party' then
									regexp = brackets_if_toplevel_alts(regexp) .. '(?C251)(?#third-party)'
								elseif option == '~third-party' then
									regexp = brackets_if_toplevel_alts(regexp) .. '(?C251)(?#~third-party)'
								elseif type_options[option] then
									regexp = re.find(regexp, [[\(\?C251\)\(\?\#(?!~?third-party)\K]])
										and re.replace(nil, nil, type_options[option]:gsub('%)', '####') .. '|')
										or brackets_if_toplevel_alts(regexp) .. '(?C251)(?#' ..
											type_options[option]:gsub('%)', '####') .. ')'
								else	--      
									regexp = nil
									break
								end
							end
							if regexp and regexp~='' then
									if line:find('^@@') and v.On then
										table.insert(AdBlockPlus_White_List, regexp)
										-- table.insert(AdBlockPlus_Request_White_List, regexp)
									else
										table.insert(AdBlockPlus_Black_List, regexp)
										-- table.insert(AdBlockPlus_Request_Black_List, regexp)
									end
							end
						else	--     CSS
							--      CSS,     
							if re.find(line, [[^[^#]*+\#(?!\#).*]]) then
								regexp = re.replace(nil, [[^[^#]*+\#\K(.*?)\(([^=)]++)\)]], [[\1#\2, \1.\2]])
								regexp = regexp:gsub('%((.-=)(.-)%)', '[%1"%2"]')
								line = regexp:gsub('#', '##', 1)
							end
							regexp = re.find(line, [[^\#\#\K.*|^.+?\#\#.*]])
							if regexp and line:sub(1,2)=='##' and v.On then
								table.insert(AdBlockPlus_CSS_List, '   ' .. regexp .. ' {display: none !important;}\r\n')
							elseif regexp then	--    CSS   
								local full_block = re.find(regexp, [[^(?>(.+?)\#\#)\*$]], 1)
								if full_block then	--   CSS     
									local tmp = re.replace(toregexp(full_block), ',', '|', true)
									table.insert(AdBlockPlus_Black_List, tmp)
									-- table.insert(AdBlockPlus_Request_Black_List, tmp)
								else
									table.insert(AdBlockPlus_CSS_With_Domain_List, regexp)
								end
							end
						end -- if regexp
					end -- for line
				end
				BreakedBlocks[i] = false
			else
				hc.put_msg('Content Master:\r\nFile error:\r\n', err)
			end
		end	-- for file

		v.Rules = v.Rules or {}
		if not BreakedBlocks[i] then
			table.insert(v.Rules, {
				Name = ' HTML-    URL (AdBlockPlus)',
				Type = 'AdBlockPlus',
				Method = 'block, edit',
				Find = re.replace(Find_Element_By_URL_In_Tag, [[!--.*?\(\*F\)\|\K]], [[<a[\s>](*SKIP)(*F)|]]),
--					Find = [[<a[\s>](*SKIP)(*F)|]] .. Find_Element_By_URL_In_Tag,
				Replace = '<!-- ********** CONTENT MASTER: Element deleted by AdBlockPlus. URL=\\2 -->',
				SubFind = AdBlockPlus_White_List[1] and
					('\\A(?=.*?(?:' .. regexp_from_list(AdBlockPlus_Black_List) .. '))(?!.*?(?:' ..
					regexp_from_list(AdBlockPlus_White_List) .. '))') or regexp_from_list(AdBlockPlus_Black_List),
				Type = 'URL',
				Functor = 'TAG_NAME',
				On = true,
			})
-- hc.put_to_log(v.Rules[#v.Rules].SubFind)
			table.insert(v.Rules, {
				Name = ' HTML-   CSS (AdBlockPlus)',
				Find = CSS_insert,
				Replace = '\r\n\r\n<!-- AdBlockPlus CSS rules. INSERTED BY CONTENT MASTER BEGIN: -->\r\n' ..
							 '<style type="text/css">\r\n' .. table.concat(AdBlockPlus_CSS_List) .. '</style>\r\n' ..
							 '<!-- AdBlockPlus CSS rules. INSERTED BY CONTENT MASTER END -->\r\n\r\n',
				__AdBlockPlus_CSS_With_Domain_List = AdBlockPlus_CSS_With_Domain_List[1] and
					(table.concat(AdBlockPlus_CSS_With_Domain_List, ' {display: none !important;}\r\n') ..
					' {display: none !important;}\r\n'),
				Counted = false,
				Once = true,
				Order = 2,
				On = true,
			})
		end
-- ---------------------------       -----------------------
	elseif v.Type=='HandyCache' then
		BreakedBlocks[i] = false
		local HandyCache_Black_List = {}		--  
		local HandyCache_White_List = {}
		local HandyCache_Request_Black_List = HC_Global_Request_Black_List
		local HandyCache_Request_White_List = HC_Global_Request_White_List
		local regexp, exception
		if v.On then
			local function list_from_file(file_name, line_regexp, list)
				for line in io.lines(hc.ini_path .. file_name) do	--      
					if re.find(line, line_regexp) then
						local tmp = re.substr(1)	--  ""
						regexp = string.gsub(toregexp(tmp:sub(2), 'hc'), '%%', '%%%%')
						regexp = tmp:gsub('^%+.*', regexp)
						if regexp~='' then
							tmp = re.substr(2)	--  ""
							exception = string.gsub(toregexp(tmp:sub(2), 'hc'), '%%', '%%%%')
							exception = tmp:gsub('^%+.*', exception)
							tmp = re.substr(3)	--  ""
							regexp = exception~='' and ('\\A(?=.*?' .. brackets_if_toplevel_alts(regexp) ..
								')(?!.*?' .. brackets_if_toplevel_alts(exception) .. ')') or regexp
							regexp = re.replace(regexp, [[(?:\\\\)*+\K\.\*\?\^]], '^')
							if tmp~='' then
								regexp = brackets_if_toplevel_alts(regexp) .. '(?C251)(?#' .. tmp:gsub('%)', '####') .. ')'
							end
							table.insert(list, regexp)
							-- table.insert(HandyCache_Request_Black_List, regexp)
						end
					end
				end
			end
			list_from_file('black.lst',
				[[^True\#~\#(?!ip\s*+\d)(.*?)\#~\#(?!ip\s*+\d)(.*?)\#~\#(.*?)\#~\#\d*$]], HandyCache_Black_List)
			list_from_file('white.lst',
				[[^(?>True\#~\#(?!ip\s*+\d)(.*?)\#~\#)(?>(?!ip\s*+\d)(.*?)\#~\#)(?>(.*?)\#~\#)True\#~\#]],
				HandyCache_White_List)
		end
		v.Rules = v.Rules or {}
		table.insert(v.Rules, {
			Name = ' HTML-  URL    ',
			Type = 'HandyCache',
			Method = 'edit',
			Find = Find_Element_By_URL_In_Tag,
			Replace = '<!-- ********** CONTENT MASTER: Element deleted by HandyCache Black List. URL=\\2 -->',
			SubFind = '\\A(?=.*?(?:' .. regexp_from_list(HandyCache_Black_List) ..
				'))(?!.*?(?:' .. regexp_from_list(HandyCache_White_List) .. '))',
			Type = 'URL',
			Functor = 'HC_SiteColumn',
			On = true,
		})
-- hc.put_to_log(v.Rules[#v.Rules].SubFind)
	elseif v.Type == 'ContentMaster' then
		if v.On then
			v.File = re.find(sfile, [[ContentMaster files=\K.+?$]]) or 'ContentMaster_Default.txt'
			for file in string.gmatch(v.File, '[^, ]+') do	--     
				local f, err = io.open(re.replace(hc.script_name, [[\\[^\\]+$]], [[\]]) .. file, 'rb')
				if f then
					f:close()
				else
				end
			end
		end
		BreakedBlocks[i] = false
	end	-- if v.Type=='AdBlockPlus'
end	-- for i,v

local delta = 0
for i,v in ipairs(BreakedBlocks) do
	if v then
		table.remove(_CM_.Data, i-delta)
		delta = delta + 1
	end
end

-- -------------------------     --------------------------------
for i,v in ipairs(_CM_.Data) do
	for _,rule in ipairs(v.Rules) do
		rule.Find = rule.Find and ('(?:' .. rule.Find .. ')')
		rule.SubFind = rule.SubFind and ('(?:' .. rule.SubFind .. ')')
		for j,w in pairs(_CM_.Lists) do
			local lst = re.replace(w, [[[\r\n]++\s*+\z]], '', true)  --  .  
			lst = re.replace(lst, [[(*ANYCRLF)^\s+]], '', true)	--     
			lst = re.replace(lst, [[[\r\n]++]], '|', true)
			lst = re.replace(lst, [[\|\|++]], '|', true)
			if j=='replacements' and rule.Find and rule.Find:find('replacements') then
				rule.Find = lst
			else
				local subj, repl = [[\(\?&]] .. j .. [[\).*]], [[\0(?(DEFINE)(?<]] .. j .. '>' .. lst .. '))'
				rule.Find = rule.Find and re.replace(rule.Find, subj, repl)
				rule.SubFind = rule.SubFind and re.replace(rule.SubFind, subj, repl)
			end
		end
	end
end
_CM_.Lists = nil

local H = {}
for i,v in ipairs(_CM_.Data) do
	H[i] = {}
	for j,rule in ipairs(v.Rules) do
		rule.Method = rule.Method or 'edit'	--    ,      
		rule.Counted = rule.Counted~=false and true	--    ,    
		rule.Order = rule.Order or 10
		s= re.find(sfile, toregexp(rule.Name) .. '=(true|false)(?:,(\\d+))?', 1)
		--    ,    
		if s~=nil then
			rule.On = not (s=='false')
		else
			rule.On = (rule.On==nil) and true or rule.On
		end
		H[i][j] = tonumber(re.substr(2) or 0)
	end
end
hc.set_global('CM_Hits', H)
_CM_.LogOn = re.find(sfile, ' =(true|false)', 1)=='true'
-- -----------------------  "" -----------------------------
local ee = (re.find(nil, [[(?| =\{\{(.*?)\}\}|\[GLOBAL EXCEPTIONS\]\r\n(.*?)\s*?\r\n\s*?(?:\r\n|\z))]], 1) or '') .. '\r\n'
_CM_.User_Exceptions_List = {}
local t = _CM_.NoAction_List
for ss in string.gmatch(ee, '[^\r\n]+') do
	table.insert(_CM_.User_Exceptions_List, ss)
	if re.find(ss, '\\S') then
		table.insert(t, ss:find('^%+') and toregexp(ss:sub(2)) or ss)
	end
end
_CM_.URL_Exception = t[1] and regexp_from_list(t) or ''
_CM_.CM_Off_Hotkey = re.find(sfile, [[  =\K.*?$]]) or 'VK_CONTROL'

_CM_.Orders = {}
local LastURLRuleOrder = 0
for _,v in ipairs(_CM_.Data) do			--    
	if v.On then								--    ,   
		for _,rule in ipairs(v.Rules) do		--   
			if rule.On and not rule.__Off then
				if rule.Order>=LastURLRuleOrder and rule.Type=='URL' then
					_CM_.LastURLRule = rule.Name
					LastURLRuleOrder = rule.Order
				end
				local order_absent = true
				for _,vv in ipairs(_CM_.Orders) do
					if rule.Order==vv then
						order_absent = false
						break
					end
				end
				if order_absent then
					table.insert(_CM_.Orders, rule.Order)
				end
			end
		end
	end
end
table.sort(_CM_.Orders)

-- ---------------------------------------------------------------
hc.set_global('CM_DATA', _CM_)
hc.set_global('CM_GLOBAL_ID', os.clock())

hc.put_to_log('Content Master: initialized from ', (re.replace(hc.script_name, [[.*\.\K.*]], [[ini]])))
